CVE Vulnerabilities

CVE-2015-7943

URL Redirection to Untrusted Site ('Open Redirect')

Published: Oct 18, 2017 | Modified: Nov 08, 2017
CVSS 3.x
6.1
MEDIUM
Source:
NVD
CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N
CVSS 2.x
5.8 MEDIUM
AV:N/AC:M/Au:N/C:P/I:P/A:N
RedHat/V2
RedHat/V3
Ubuntu
MEDIUM

Open redirect vulnerability in the Overlay module in Drupal 7.x before 7.41, the jQuery Update module 7.x-2.x before 7.x-2.7 for Drupal, and the LABjs module 7.x-1.x before 7.x-1.8 allows remote attackers to redirect users to arbitrary web sites and conduct phishing attacks via unspecified vectors. NOTE: this vulnerability exists because of an incomplete fix for CVE-2015-3233.

Weakness

A web application accepts a user-controlled input that specifies a link to an external site, and uses that link in a Redirect. This simplifies phishing attacks.

Affected Software

Name Vendor Start Version End Version
Drupal Drupal 7.0 (including) 7.0 (including)
Drupal Drupal 7.0-alpha1 (including) 7.0-alpha1 (including)
Drupal Drupal 7.0-alpha2 (including) 7.0-alpha2 (including)
Drupal Drupal 7.0-alpha3 (including) 7.0-alpha3 (including)
Drupal Drupal 7.0-alpha4 (including) 7.0-alpha4 (including)
Drupal Drupal 7.0-alpha5 (including) 7.0-alpha5 (including)
Drupal Drupal 7.0-alpha6 (including) 7.0-alpha6 (including)
Drupal Drupal 7.0-alpha7 (including) 7.0-alpha7 (including)
Drupal Drupal 7.0-beta1 (including) 7.0-beta1 (including)
Drupal Drupal 7.0-beta2 (including) 7.0-beta2 (including)
Drupal Drupal 7.0-beta3 (including) 7.0-beta3 (including)
Drupal Drupal 7.0-dev (including) 7.0-dev (including)
Drupal Drupal 7.0-rc1 (including) 7.0-rc1 (including)
Drupal Drupal 7.0-rc2 (including) 7.0-rc2 (including)
Drupal Drupal 7.0-rc3 (including) 7.0-rc3 (including)
Drupal Drupal 7.0-rc4 (including) 7.0-rc4 (including)
Drupal Drupal 7.1 (including) 7.1 (including)
Drupal Drupal 7.2 (including) 7.2 (including)
Drupal Drupal 7.3 (including) 7.3 (including)
Drupal Drupal 7.4 (including) 7.4 (including)
Drupal Drupal 7.5 (including) 7.5 (including)
Drupal Drupal 7.6 (including) 7.6 (including)
Drupal Drupal 7.7 (including) 7.7 (including)
Drupal Drupal 7.8 (including) 7.8 (including)
Drupal Drupal 7.9 (including) 7.9 (including)
Drupal Drupal 7.10 (including) 7.10 (including)
Drupal Drupal 7.11 (including) 7.11 (including)
Drupal Drupal 7.12 (including) 7.12 (including)
Drupal Drupal 7.13 (including) 7.13 (including)
Drupal Drupal 7.14 (including) 7.14 (including)
Drupal Drupal 7.15 (including) 7.15 (including)
Drupal Drupal 7.16 (including) 7.16 (including)
Drupal Drupal 7.17 (including) 7.17 (including)
Drupal Drupal 7.18 (including) 7.18 (including)
Drupal Drupal 7.19 (including) 7.19 (including)
Drupal Drupal 7.20 (including) 7.20 (including)
Drupal Drupal 7.21 (including) 7.21 (including)
Drupal Drupal 7.22 (including) 7.22 (including)
Drupal Drupal 7.23 (including) 7.23 (including)
Drupal Drupal 7.24 (including) 7.24 (including)
Drupal Drupal 7.25 (including) 7.25 (including)
Drupal Drupal 7.26 (including) 7.26 (including)
Drupal Drupal 7.27 (including) 7.27 (including)
Drupal Drupal 7.28 (including) 7.28 (including)
Drupal Drupal 7.29 (including) 7.29 (including)
Drupal Drupal 7.30 (including) 7.30 (including)
Drupal Drupal 7.31 (including) 7.31 (including)
Drupal Drupal 7.32 (including) 7.32 (including)
Drupal Drupal 7.33 (including) 7.33 (including)
Drupal Drupal 7.34 (including) 7.34 (including)
Drupal Drupal 7.35 (including) 7.35 (including)
Drupal Drupal 7.36 (including) 7.36 (including)
Drupal Drupal 7.37 (including) 7.37 (including)
Drupal Drupal 7.38 (including) 7.38 (including)
Drupal Drupal 7.39 (including) 7.39 (including)
Drupal Drupal 7.40 (including) 7.40 (including)
Jquery_update Jquery_update_project 7.x-2.0 (including) 7.x-2.0 (including)
Jquery_update Jquery_update_project 7.x-2.1 (including) 7.x-2.1 (including)
Jquery_update Jquery_update_project 7.x-2.2 (including) 7.x-2.2 (including)
Jquery_update Jquery_update_project 7.x-2.3 (including) 7.x-2.3 (including)
Jquery_update Jquery_update_project 7.x-2.4 (including) 7.x-2.4 (including)
Jquery_update Jquery_update_project 7.x-2.5 (including) 7.x-2.5 (including)
Jquery_update Jquery_update_project 7.x-2.6 (including) 7.x-2.6 (including)
Labjs Labjs_project 7.x-1.0 (including) 7.x-1.0 (including)
Labjs Labjs_project 7.x-1.0-beta1 (including) 7.x-1.0-beta1 (including)
Labjs Labjs_project 7.x-1.0-rc1 (including) 7.x-1.0-rc1 (including)
Labjs Labjs_project 7.x-1.1 (including) 7.x-1.1 (including)
Labjs Labjs_project 7.x-1.2 (including) 7.x-1.2 (including)
Labjs Labjs_project 7.x-1.3 (including) 7.x-1.3 (including)
Labjs Labjs_project 7.x-1.4 (including) 7.x-1.4 (including)
Labjs Labjs_project 7.x-1.5 (including) 7.x-1.5 (including)
Labjs Labjs_project 7.x-1.6 (including) 7.x-1.6 (including)
Labjs Labjs_project 7.x-1.7 (including) 7.x-1.7 (including)
Drupal7 Ubuntu artful *
Drupal7 Ubuntu precise *
Drupal7 Ubuntu trusty *
Drupal7 Ubuntu trusty/esm *
Drupal7 Ubuntu upstream *
Drupal7 Ubuntu vivid *
Drupal7 Ubuntu wily *
Drupal7 Ubuntu yakkety *
Drupal7 Ubuntu zesty *

Potential Mitigations

  • Assume all input is malicious. Use an “accept known good” input validation strategy, i.e., use a list of acceptable inputs that strictly conform to specifications. Reject any input that does not strictly conform to specifications, or transform it into something that does.
  • When performing input validation, consider all potentially relevant properties, including length, type of input, the full range of acceptable values, missing or extra inputs, syntax, consistency across related fields, and conformance to business rules. As an example of business rule logic, “boat” may be syntactically valid because it only contains alphanumeric characters, but it is not valid if the input is only expected to contain colors such as “red” or “blue.”
  • Do not rely exclusively on looking for malicious or malformed inputs. This is likely to miss at least one undesirable input, especially if the code’s environment changes. This can give attackers enough room to bypass the intended validation. However, denylists can be useful for detecting potential attacks or determining which inputs are so malformed that they should be rejected outright.
  • Use a list of approved URLs or domains to be used for redirection.
  • When the set of acceptable objects, such as filenames or URLs, is limited or known, create a mapping from a set of fixed input values (such as numeric IDs) to the actual filenames or URLs, and reject all other inputs.
  • For example, ID 1 could map to “/login.asp” and ID 2 could map to “http://www.example.com/". Features such as the ESAPI AccessReferenceMap [REF-45] provide this capability.
  • Understand all the potential areas where untrusted inputs can enter your software: parameters or arguments, cookies, anything read from the network, environment variables, reverse DNS lookups, query results, request headers, URL components, e-mail, files, filenames, databases, and any external systems that provide data to the application. Remember that such inputs may be obtained indirectly through API calls.
  • Many open redirect problems occur because the programmer assumed that certain inputs could not be modified, such as cookies and hidden form fields.

References